<?php
/*
HDDTEMP Template for cacti 0.8.6h v0.8.1
cyril@pawelko.net
*/

$no_http_headers = true;
$port = 7634;

function getdisks($host,$port) {
  $fp = fsockopen($host,$port, $errno, $errstr, 10);
  if ($fp) {
    $ligne = fgets($fp);
    fclose($fp);
  }
  $ligne=trim($ligne,"|");
  $disks = array();
  $disks = explode("||",$ligne);
  foreach ($disks as $i => $val) {
    $disks[$i]=explode("|",$val);
  }
  return $disks;
}

function printindex($disks){
  foreach ($disks as $i => $val) {
    print($disks[$i][0])."\n";
  }
}

function query($disks,$query){
  switch ($query){
  case "device" : $col = 0; break;
  case "model" : $col = 1; break;
  case "unit" : $col = 3; break;
  }
  foreach ($disks as $i => $val) {
    print($disks[$i][0]).":".$disks[$i][$col]."\n";
  }
}

function get($disks,$data,$index){
  if ( $data == "temperature" ) {
    foreach ($disks as $i => $val) {
      if ($disks[$i][0] == $index) {
	//	print($disks[$i][0]).":".$disks[$i][2]."\n";
	print($disks[$i][2]."\n");
      }
    }
  }
}

$action = $_SERVER["argv"][2];

switch ($action){
 case "index" : printindex(getdisks($_SERVER["argv"][1],$port)); break;
 case "query" : query(getdisks($_SERVER["argv"][1],$port),$_SERVER["argv"][3]); break;
 case "get" : if (count($_SERVER["argv"]) == 5) {
    get(getdisks($_SERVER["argv"][1],$port),$_SERVER["argv"][3],$_SERVER["argv"][4]);
  }
   break;
 }
?>
